import os
import renpy
import subprocess

class Editor(renpy.editor.Editor):

    def begin(self, new_window=False, **kwargs):
        
        args = [ ]
        
        mydir = os.path.dirname(__file__)
        base = os.path.join(mydir, "../scite/")
        
        if renpy.windows:
            scite = base + 'scite.exe'
            
        else:
            scite = base + 'scite'
        
        scite = os.path.relpath(scite)
        
        args = [scite]
        
        if new_window:
            args.append("-newplainview")
        else:
            args.append("-reuseview")
    
        self.arguments = args
    
    def open(self, filename, line=None, **kwargs):
        filename = renpy.exports.fsencode(filename)
        self.arguments.append(filename)
        
        if line is not None:
            self.arguments.append("-goto:{0}".format(line))

    def end(self, **kwargs):
        print self.arguments
        subprocess.Popen(self.arguments)

